import ROOT
from ROOT import TMath

#Names of the observables we want to have in the reprocessed files
obsList = ("pTBalance", "Mjj", "dEtajj", "dRjj", "Sin0p5dFi", "EtaCentrality", "pTCentrality", "Ejets")

#A function, that take two jets' four-vectors as an input and 
#calculates the observable based on the provided key (obsName)
def observables( jet1, jet2, boson, obsName ):
    funcObsList = {
    obsList[0]:TMath.Sqrt( ( jet1.Px() + jet2.Px() + boson.Px() )*( jet1.Px() + jet2.Px() + boson.Px() ) + 
    ( jet1.Py() + jet2.Py() + boson.Py() )*( jet1.Py() + jet2.Py() + boson.Py() ) )/( jet1.Pt() + jet2.Pt() + boson.Pt() ), 
    obsList[1]:(jet1 + jet2).M(),
    obsList[2]:TMath.Abs( jet1.Eta() - jet2.Eta() ),
    obsList[3]:TMath.Sqrt( ( jet1.Eta() - jet2.Eta() )*( jet1.Eta() - jet2.Eta() )  + 
    ( jet1.Phi() - jet2.Phi() )*( jet1.Phi() - jet2.Phi() ) ),
    obsList[4]:TMath.Sin( TMath.Abs( ( jet1.Phi() - jet2.Phi() )/2. ) ),
    obsList[5]:TMath.Abs( ( boson.Eta() - ( jet1.Eta() - jet2.Eta() )/2. )/( jet1.Eta() - jet2.Eta() ) ),
    obsList[6]:TMath.Sqrt( ( boson.Px() - jet1.Px()/2. - jet1.Px()/2. )*( boson.Px() - jet1.Px()/2. - jet1.Px()/2. ) + 
    ( boson.Py() - jet1.Py()/2. - jet1.Py()/2. )*( boson.Py() - jet1.Py()/2. - jet1.Py()/2. ) )/TMath.Sqrt( ( jet1.Px() - jet2.Px() )*( jet1.Px() - jet2.Px() ) + 
    ( jet1.Py() - jet2.Py() )*( jet1.Py() - jet2.Py() ) ),
    obsList[7]:( jet1.Pt() + jet2.Pt() )/( jet1.E() + jet2.E() )
    }
    if obsName in obsList: return funcObsList[obsList[obsList.index(obsName)]]
    else: print "Variable " + ''.join(obsName) + " is not defined!"